"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const build_plugin_1 = require("./build-plugin");
const core = require("@angular-devkit/core");
const path = require("path");
jest.mock('root/folder/file.plugin.js', () => ({ pre: jest.fn(value => value) }), { virtual: true });
jest.mock('@angular-devkit/core');
jest.mock('path');
describe('BuildPlugin Test', () => {
    const options = { plugin: 'folder/file.plugin.js' };
    const root = 'root';
    beforeAll(() => {
        jest.spyOn(core, 'getSystemPath').mockImplementation(value => value);
        jest.spyOn(path, 'resolve').mockImplementation((...values) => values.join('/'));
    });
    describe('#loadPlugin', () => {
        beforeEach(() => build_plugin_1.BuildPlugin.loadPlugin(root, options));
        it('should resolve the plugin path', () => {
            expect(core.getSystemPath).toHaveBeenLastCalledWith(root);
            expect(path.resolve).toHaveBeenLastCalledWith(root, options.plugin);
        });
        it('should load the plugin correctly', () => {
            expect(build_plugin_1.BuildPlugin.plugin).toEqual({ pre: expect.any(Function) });
        });
    });
    describe('#runHook', () => {
        const data = { sample: true };
        it('should return the value if the hook method exist', () => {
            build_plugin_1.BuildPlugin.loadPlugin(root, options);
            const hookReturnValue = build_plugin_1.BuildPlugin.runHook('pre', data);
            expect(hookReturnValue).toEqual(data);
        });
        it('should return undefined if the hook method not exist', () => {
            const hookReturnValue = build_plugin_1.BuildPlugin.runHook('post', data);
            expect(hookReturnValue).toBeUndefined();
        });
    });
});
//# sourceMappingURL=build-plugin.spec.js.map